"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var actions_1 = require("../state/actions");
var store_1 = require("../state/store");
var types_1 = require("../types/types");
var git_util_1 = require("../util/git-util");
var keys_def_1 = require("../util/keys-def");
var interface_elements_1 = require("./interface-elements");
var notification_1 = require("./notification");
exports.getCommitElement = function () {
    var commitElement = interface_elements_1.getPageableBoxElement({
        alwaysScroll: true,
        bottom: 0,
        keys: true,
        left: 0,
        name: 'commitContentContainer',
        right: 0,
        scrollable: true,
        top: 0,
        vi: true,
    });
    commitElement.key([keys_def_1.keys.RIGHT, keys_def_1.keys.SHIFT_DOWN, keys_def_1.keys.SHIFT_J], function () {
        return actions_1.Actions.updateIndex(1);
    });
    commitElement.key([keys_def_1.keys.LEFT, keys_def_1.keys.SHIFT_K, keys_def_1.keys.SHIFT_UP], function () {
        return actions_1.Actions.updateIndex(-1);
    });
    commitElement.key([keys_def_1.keys.ENTER, keys_def_1.keys.SPACE], function () {
        return actions_1.Actions.updateView(types_1.View.LIST);
    });
    commitElement.focus();
    store_1.doSubscribe(['SHA', 'view'], commitElement, updateCommitElement);
    return commitElement;
};
var updateCommitElement = function (_a) {
    var commitElement = _a.element, state = _a.state;
    return __awaiter(void 0, void 0, void 0, function () {
        var SHA, view, commitContent, error_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    SHA = state.SHA, view = state.view;
                    if (view !== types_1.View.COMMIT) {
                        commitElement.content = '';
                        return [2 /*return*/, false];
                    }
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, git_util_1.gitShow(SHA)];
                case 2:
                    commitContent = _b.sent();
                    commitElement.setContent(commitContent);
                    commitElement.scrollTo(0);
                    return [2 /*return*/, true];
                case 3:
                    error_1 = _b.sent();
                    notification_1.notifier.warn("Couldn't retrieve commit content for " + SHA);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/, false];
            }
        });
    });
};
//# sourceMappingURL=commit-view.js.map