"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Blessed = require("blessed");
var keys_def_1 = require("../util/keys-def");
exports.getBoxElement = function (options) {
    return Blessed.box(options);
};
exports.getPageableBoxElement = function (options) {
    var element = exports.getBoxElement(options);
    element.key([keys_def_1.keys.F, keys_def_1.keys.PAGEDOWN], function () {
        element.scroll(+element.height);
        element.screen.render();
    });
    element.key([keys_def_1.keys.B, keys_def_1.keys.PAGEUP], function () {
        element.scroll(-element.height);
        element.screen.render();
    });
    return element;
};
exports.getListElement = function (options) {
    return Blessed.list(options);
};
exports.getScreenElement = function (options) {
    return Blessed.screen(options);
};
exports.getTextElement = function (options) {
    return Blessed.text(options);
};
//# sourceMappingURL=interface-elements.js.map