"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var actions_1 = require("../state/actions");
var types_1 = require("../types/types");
var command_util_1 = require("../util/command-util");
var config_util_1 = require("../util/config-util");
var interface_actions_1 = require("../util/interface-actions");
var keys_def_1 = require("../util/keys-def");
var log_util_1 = require("../util/log-util");
var help_dialog_1 = require("./help-dialog");
var interface_elements_1 = require("./interface-elements");
var main_content_container_1 = require("./main-content-container");
var notification_1 = require("./notification");
var status_bar_1 = require("./status-bar");
var quit = function () { return process.exit(0); };
exports.getScreen = function (commands) {
    var screen = interface_elements_1.getScreenElement({
        autoPadding: true,
        fullUnicode: true,
        name: 'screen',
        smartCSR: true,
    });
    screen.key([keys_def_1.keys.CONTROL_C, keys_def_1.keys.Q], quit);
    var helpDialogHider = new Hider(help_dialog_1.getHelpDialog());
    var escapeKeyFunction = function () {
        helpDialogHider.hide();
        actions_1.Actions.updateView(types_1.View.LIST);
    };
    if (config_util_1.getUseLegacyEscapeKeyBehavior()) {
        escapeKeyFunction = quit;
    }
    screen.key(keys_def_1.keys.ESCAPE, escapeKeyFunction);
    screen._listenedMouse = true;
    var wrapper = interface_elements_1.getBoxElement({
        bottom: 0,
        left: 0,
        name: 'wrapper',
        right: 0,
        top: 0,
    });
    screen.append(wrapper);
    wrapper.append(main_content_container_1.getMainContentContainer());
    wrapper.append(status_bar_1.getStatusBar());
    wrapper.append(notification_1.getNotificationContainer());
    wrapper.append(help_dialog_1.getHelpDialog());
    screen.key(keys_def_1.keys.QUESTION_MARK, function () {
        if (helpDialogHider.hidden()) {
            screen.saveFocus();
            helpDialogHider.focus();
        }
        helpDialogHider.toggle();
        if (helpDialogHider.hidden()) {
            screen.restoreFocus();
        }
    });
    screen.key(keys_def_1.keys.LESS_THAN, interface_actions_1.doOpenConfigFile);
    screen.key(keys_def_1.keys.M, interface_actions_1.doCopyCommitMessage);
    screen.key(keys_def_1.keys.O, interface_actions_1.doOpenFilesInEditor);
    screen.key(keys_def_1.keys.R, function () { return log_util_1.generateLog(screen); });
    screen.key(keys_def_1.keys.X, interface_actions_1.doMarkCommit);
    screen.key(keys_def_1.keys.Y, interface_actions_1.doCopyCommitSHA);
    var wrapperHider = new Hider(wrapper);
    var _loop_1 = function (command) {
        screen.key(command.key, function () { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (command.foreground) {
                            wrapperHider.hide();
                        }
                        return [4 /*yield*/, command_util_1.registerCommand(screen, command)];
                    case 1:
                        _a.sent();
                        if (command.foreground) {
                            wrapperHider.show();
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, commands_1 = commands; _i < commands_1.length; _i++) {
        var command = commands_1[_i];
        _loop_1(command);
    }
    return screen;
};
var Hider = /** @class */ (function () {
    function Hider(element) {
        this.element = element;
    }
    Hider.prototype.focus = function () {
        this.element.focus();
    };
    Hider.prototype.hide = function () {
        this.element.hide();
        this.element.screen.render();
    };
    Hider.prototype.hidden = function () {
        return this.element.hidden;
    };
    Hider.prototype.show = function () {
        this.element.show();
        this.element.screen.render();
    };
    Hider.prototype.toggle = function () {
        this.element.toggle();
        this.element.screen.render();
    };
    return Hider;
}());
//# sourceMappingURL=screen.js.map