"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Blessed = require("blessed");
exports.getSearchInput = function (valueCallback) {
    var input = Blessed.textarea({
        border: { fg: 3, type: 'line' },
        bottom: 0,
        height: 3,
        inputOnFocus: true,
        label: '/ Search:',
        name: 'searchInput',
        padding: {
            left: 1,
        },
        width: '100%',
    });
    input.onceKey('enter', function () {
        valueCallback(input.value.trim());
        input.submit();
    });
    input.on('action', function () {
        input.destroy();
        input.screen.render();
    });
    return input;
};
//# sourceMappingURL=search-bar.js.map