"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var util_functions_1 = require("../util/util-functions");
ava_1.default('stringToCommandArray', function (t) {
    t.deepEqual(util_functions_1.stringToCommandArray(''), []);
    t.deepEqual(util_functions_1.stringToCommandArray('hello world'), ['hello', 'world']);
    t.deepEqual(util_functions_1.stringToCommandArray('one "two three" four'), [
        'one',
        'two three',
        'four',
    ]);
    t.deepEqual(util_functions_1.stringToCommandArray('one two "three four"'), [
        'one',
        'two',
        'three four',
    ]);
    t.deepEqual(util_functions_1.stringToCommandArray('git -p diff [%SHA_RANGE%] --name-only | sed s,/src/.*,, | sed s,/build.gradle,, | uniq -c | sort -r | less'), [
        'git',
        '-p',
        'diff',
        '[%SHA_RANGE%]',
        '--name-only',
        '|',
        'sed',
        's,/src/.*,,',
        '|',
        'sed',
        's,/build.gradle,,',
        '|',
        'uniq',
        '-c',
        '|',
        'sort',
        '-r',
        '|',
        'less',
    ]);
});
//# sourceMappingURL=test-string-to-command-array.js.map