"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var notification_1 = require("../interface/notification");
var actions_1 = require("../state/actions");
var store_1 = require("../state/store");
var config_util_1 = require("./config-util");
var external_commands_1 = require("./external-commands");
var git_util_1 = require("./git-util");
exports.doCopyCommitMessage = function () { return __awaiter(void 0, void 0, void 0, function () {
    var message, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, external_commands_1.copyCommitMessageToClipboard(getSHA())];
            case 1:
                message = _a.sent();
                notification_1.notifier.success("Copied commit message to the clipoard:\n\n\"" + message + "\"");
                return [3 /*break*/, 3];
            case 2:
                error_1 = _a.sent();
                notification_1.notifier.error("Could not copy the commit message to the clipboard:\n\n" + error_1.message);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.doCopyCommitSHA = function () { return __awaiter(void 0, void 0, void 0, function () {
    var SHA, error_2;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                SHA = getSHA();
                return [4 /*yield*/, external_commands_1.copySHAToClipboard(SHA)];
            case 1:
                _a.sent();
                notification_1.notifier.success("Copied SHA to the clipboard: " + SHA);
                return [3 /*break*/, 3];
            case 2:
                error_2 = _a.sent();
                notification_1.notifier.error("Could not copy the SHA to the clipboard:\n\n" + error_2.message);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.doOpenConfigFile = function () { return __awaiter(void 0, void 0, void 0, function () {
    var error_3;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, external_commands_1.openFile(config_util_1.getConfigFilePath())];
            case 1:
                _a.sent();
                notification_1.notifier.success("Opened the config file at: " + config_util_1.getConfigFilePath());
                return [3 /*break*/, 3];
            case 2:
                error_3 = _a.sent();
                notification_1.notifier.error("Could not open the config file at " + config_util_1.getConfigFilePath() + ":\n\n" + error_3.message);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.doOpenFilesInEditor = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, doCommandWithMaybeMarkedCommit(external_commands_1.openFilesFromCommitRange, 'Could not open the files')];
    });
}); };
exports.doMarkCommit = function () {
    var commit = getSHA();
    if (getMarkedSHA() === commit) {
        unmarkAnchorCommit();
    }
    else {
        actions_1.Actions.markSHA(commit);
        notification_1.notifier.info("Marked commit for diffing: " + commit);
    }
};
// Helpers
var doCommandWithMaybeMarkedCommit = function (command, errorText) { return __awaiter(void 0, void 0, void 0, function () {
    var markedSHA, SHA, sorted, _a, error_4;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                markedSHA = getMarkedSHA();
                _b.label = 1;
            case 1:
                _b.trys.push([1, 6, , 7]);
                SHA = getSHA();
                if (!markedSHA) return [3 /*break*/, 3];
                return [4 /*yield*/, git_util_1.sortSHAs(markedSHA, SHA)];
            case 2:
                _a = _b.sent();
                return [3 /*break*/, 4];
            case 3:
                _a = [SHA, SHA];
                _b.label = 4;
            case 4:
                sorted = _a;
                return [4 /*yield*/, command(sorted[0], sorted[1])];
            case 5:
                _b.sent();
                return [3 /*break*/, 7];
            case 6:
                error_4 = _b.sent();
                notification_1.notifier.error(errorText + ":\n\n" + error_4.message);
                return [3 /*break*/, 7];
            case 7:
                if (markedSHA) {
                    unmarkAnchorCommit();
                }
                return [2 /*return*/];
        }
    });
}); };
var getMarkedSHA = function () { return store_1.store.getState().markedSHA; };
var getSHA = function () { return store_1.store.getState().SHA; };
var unmarkAnchorCommit = function () {
    actions_1.Actions.markSHA(null);
    notification_1.notifier.info("Unmarked commit");
};
//# sourceMappingURL=interface-actions.js.map