"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var actions_1 = require("../state/actions");
var types_1 = require("../types/types");
var logger_1 = require("./logger");
var search_1 = require("./search");
var stash_1 = require("./stash");
var util_functions_1 = require("./util-functions");
var gitLogProcess;
exports.generateLog = function (screen) {
    if (gitLogProcess) {
        gitLogProcess.stdout.removeAllListeners();
        gitLogProcess.stderr.removeAllListeners();
        gitLogProcess.removeAllListeners();
        gitLogProcess.kill();
    }
    search_1.searchIndex.clearIndex();
    actions_1.Actions.clearLog();
    gitLogProcess = child_process_1.spawn('git', __spreadArrays([
        'log',
        '--color=always'
    ], stash_1.stash.get(stash_1.GIT_LOG_ARGS)));
    var errorString = '';
    var counter = util_functions_1.getCounter();
    gitLogProcess.stdout.setEncoding('utf8');
    gitLogProcess.stdout.on('data', function (data) {
        var lines = data.trimRight().split('\n');
        lines.forEach(function (line) {
            search_1.searchIndex.indexLine(counter.next().value, line);
        });
        actions_1.Actions.addCommits(lines);
    });
    gitLogProcess.stderr.on('data', function (data) { return (errorString += data); });
    gitLogProcess.on('close', function (code) {
        if (code > 0) {
            screen.destroy();
            logger_1.logger.error('\nGIT LOG ERROR:');
            logger_1.logger.error(errorString);
            process.exit(code);
        }
        else {
            actions_1.Actions.updateStatus(types_1.Status.LOG_COMPLETED);
        }
    });
    screen.render();
};
//# sourceMappingURL=log-util.js.map